﻿local L = AceLibrary("AceLocale-2.2"):new("VanasKoSDefaultLists");

VanasKoSDefaultLists = VanasKoS:NewModule("DefaultLists");

local dewdrop = AceLibrary("Dewdrop-2.0");

L:RegisterTranslations("enUS", function() return {
	["Player KoS"] = true,
	["Guild KoS"] = true,
	["Nicelist"] = true,
	["Hatelist"] = true,
	["Entry %s is already on Hatelist"] = true,
	["Entry %s is already on Nicelist"] = true,
	["%s  Level %s %s %s %s"] = "%s  |cffffffffLevel %s %s %s |r|cffff00ff%s|r",
	["%s (last seen: %s ago)"] = true,
	["%s (never seen)"] = true,
	["0 Secs"] = true,
	["%s  %s"] = "%s  |cffff00ff%s|r",

	["Level %s %s %s"] = "Level |cffffffff%s %s %s|r",
	["Last seen at %s in %s"] = "Last seen at |cff00ff00%s|r |cffffffffin|r |cff00ff00%s|r|r",
	["Owner: %s"] = "Owner: |cffffffff%s|r",
	["Creator: %s"] = "Creator: |cffffffff%s|r",
	["Created: %s"] = "Created: |cffffffff%s|r",
	["Received from: %s"] = "Received from: |cffffffff%s|r",
	["Last updated: %s"] = "Last updated: |cffffffff%s|r",
	
	["PvP Encounter:"] = true,
	["%s: Win in %s (%s)"] = "%s: |cff00ff00Win|r |cffffffffin|r |cffffffff%s (|r|cffff00ff%s|r|cffffffff)|r",
	["%s: Loss in %s (%s)"] = "%s: |cffff0000Loss|r |cffffffffin|r |cffffffff%s (|r|cffff00ff%s|r|cffffffff)|r",
	
	["Move to Player KoS"] = true,
	["Move to Hatelist"] = true,
	["Move to Nicelist"] = true,
	["Wanted"] = true,
	["Remove Entry"] = true,
} end);

L:RegisterTranslations("deDE", function() return {
	["Player KoS"] = "Spieler KoS",
	["Guild KoS"] = "Gilden KoS",
	["Nicelist"] = "Nette Leute Liste",
	["Hatelist"] = "Hassliste",
	["Entry %s is already on Hatelist"] = "Eintrag %s ist bereits auf Hassliste",
	["Entry %s is already on Nicelist"] = "Eintrag %s ist bereits auf Nette-Leuteliste",
	["%s  Level %s %s %s %s"] = "%s  |cffffffffLevel %s %s %s |r|cffff00ff%s|r",
	["%s (last seen: %s ago)"] = "%s (zuletzt vor %s gesehen)",
	["%s (never seen)"] = "%s (noch nicht gesehen)",
	["0 Secs"] = "0 Seks",
	["%s  %s"] = "%s  |cffff00ff%s|r",

	["Level %s %s %s"] = "Level |cffffffff%s %s %s|r",
	["Last seen at %s in %s"] = "Zuletzt gesehen am |cff00ff00%s|r |cffffffffin|r |cff00ff00%s|r|r",
	["Owner: %s"] = "Eigentümer: |cffffffff%s|r",
	["Creator: %s"] = "Ersteller: |cffffffff%s|r",
	["Created: %s"] = "Erstellt am: |cffffffff%s|r",
	["Received from: %s"] = "Erhalten von: |cffffffff%s|r",
	["Last updated: %s"] = "Zuletzt geändert: |cffffffff%s|r",

	["PvP Encounter:"] = "PvP-Begegnungen:",
	["%s: Win in %s (%s)"] = "%s: |cff00ff00Sieg|r |cffffffffin|r |cffffffff%s (|r|cffff00ff%s|r|cffffffff)|r",
	["%s: Loss in %s (%s)"] = "%s: |cffff0000Verl.|r |cffffffffin|r |cffffffff%s (|r|cffff00ff%s|r|cffffffff)|r",

	["Move to Player KoS"] = "Auf Spieler-KoS Liste verschieben",
	["Move to Hatelist"] = "Auf Hassliste verschieben",
	["Move to Nicelist"] = "Auf Nette-Leute-Liste verschieben",
	["Wanted"] = "Gesucht",
	["Remove Entry"] = "Eintrag löschen",
} end);

L:RegisterTranslations("frFR", function() return {
	["Player KoS"] = "Joueur KoS",
	["Guild KoS"] = "Guilde KoS",
	["Nicelist"] = "Liste blanche",
	["Hatelist"] = "Liste noire",
	["Entry %s is already on Hatelist"] = "L'entr\195\169e %s est d\195\169j\195\160 dans la liste noire",
	["Entry %s is already on Nicelist"] = "L'entr\195\169e %s est d\195\169j\195\160 dans la liste blanche",
	["%s  Level %s %s %s %s"] = "%s  |cffffffffLevel %s %s %s |r|cffff00ff%s|r",
	["%s (last seen: %s ago)"] = "%s (vu pour la derni\195\168re fois: %s)",
	["%s (never seen)"] = "%s (jamais vu)",
	["0 Secs"] = "0 Sec.",
	["%s  %s"] = "%s  |cffff00ff%s|r",

	["Level %s %s %s"] = "Level |cffffffff%s %s %s|r",
	["Last seen at %s in %s"] = "Dernièrement vu le |cff00ff00%s|r |cffffffffà|r |cff00ff00%s|r|r",
	["Owner: %s"] = "Propriétaire: |cffffffff%s|r",
	["Creator: %s"] = "Créateur: |cffffffff%s|r",
	["Created: %s"] = "Créé: |cffffffff%s|r",
	["Received from: %s"] = "Reçu de: |cffffffff%s|r",
	["Last updated: %s"] = "Dernière mise à jour: |cffffffff%s|r",
	["PvP Encounter:"] = "Rencontre PvP:",
	["%s: Win in %s (%s)"] = "%s: |cff00ff00Victoire|r |cffffffffà|r |cffffffff%s (|r|cffff00ff%s|r|cffffffff)|r",
	["%s: Loss in %s (%s)"] = "%s: |cffff0000Défaite|r |cffffffffà|r |cffffffff%s (|r|cffff00ff%s|r|cffffffff)|r",

--	["Move to Player KoS"] = true,
--	["Move to Hatelist"] = true,
--	["Move to Nicelist"] = true,
--	["Wanted"] = true,
--	["Remove Entry"] = true,
} end);

L:RegisterTranslations("koKR", function() return {
	["Player KoS"] = "KoS 플레이어",
	["Guild KoS"] = "KoS 길드",
	["Nicelist"] = "호인명부",
	["Hatelist"] = "악인명부",
	["Entry %s is already on Hatelist"] = "%s|1은;는; 이미 악인명부에 존재합니다.",
	["Entry %s is already on Nicelist"] = "%s|1은;는; 이미 호인명부에 존재합니다.",
	["%s  Level %s %s %s %s"] = "%s  |cffffffff레벨 %s %s %s |r|cffff00ff%s|r",
	["%s (last seen: %s ago)"] = "%s (최종 발견: %s 전)",
	["%s (never seen)"] = "%s (본적 없음)",
	["0 Secs"] = "0 초",
	["%s  %s"] = "%s  |cffff00ff%s|r",

	["Level %s %s %s"] = "레벨 |cffffffff%s %s %s |r",
	["Last seen at %s in %s"] = "|cff00ff00%s|r 마지막 발견 |cff00ff00%s|r |cffffffff내|r|r",
	["Owner: %s"] = "소유자: |cffffffff%s|r",
	["Creator: %s"] = "작성자: |cffffffff%s|r",
	["Created: %s"] = "작성: |cffffffff%s|r",
	["Received from: %s"] = "수신: |cffffffff%s|r",
	["Last updated: %s"] = "마지막 갱신: |cffffffff%s|r",
	["PvP Encounter:"] = "PvP 교전:",
	["%s: Win in %s (%s)"] = "%s: |cffffffff%s|r |cffffffff에서|r |cff00ff00승|r |cffffffff(|r|cffff00ff%s|r|cffffffff)|r",
	["%s: Loss in %s (%s)"] = "%s: |cffffffff%s|r |cffffffff에서|r |cffff0000패|r |cffffffff(|r|cffff00ff%s|r|cffffffff)|r",

--	["Move to Player KoS"] = true,
--	["Move to Hatelist"] = true,
--	["Move to Nicelist"] = true,
--	["Wanted"] = true,
--	["Remove Entry"] = true,
} end);

function VanasKoSDefaultLists:OnInitialize()
	VanasKoS:RegisterDefaults("DefaultLists", "realm", {
		koslist = {
			players = {
			},
			guilds = {
			} 
		},
		hatelist = {
			players = {
			},
		},
		nicelist = {
			players = {
			},
		},
	});

	self.db = VanasKoS:AcquireDBNamespace("DefaultLists");

	-- import of old data, will be removed in some version in the future
	if(VanasKoS.db.realm.koslist) then
		self.db.realm.koslist = VanasKoS.db.realm.koslist;
		VanasKoS.db.realm.koslist = nil;
	end
	if(VanasKoS.db.realm.hatelist) then
		self.db.realm.hatelist = VanasKoS.db.realm.hatelist;
		VanasKoS.db.realm.hatelist = nil;
	end
	if(VanasKoS.db.realm.nicelist) then
		self.db.realm.nicelist = VanasKoS.db.realm.nicelist;
		VanasKoS.db.realm.nicelist = nil;
	end
	
	VanasKoS:RegisterList(1, "PLAYERKOS", L["Player KoS"], self);
	VanasKoS:RegisterList(2, "GUILDKOS", L["Guild KoS"], self);
	VanasKoS:RegisterList(3, "HATELIST", L["Hatelist"], self);
	VanasKoS:RegisterList(4, "NICELIST", L["Nicelist"], self);

	VanasKoSGUI:RegisterList("PLAYERKOS", self);
	VanasKoSGUI:RegisterList("GUILDKOS", self);
	VanasKoSGUI:RegisterList("HATELIST", self);
	VanasKoSGUI:RegisterList("NICELIST", self);
	
	VANASKOS.showList = "PLAYERKOS";
	
	local frame = CreateFrame("Frame", nil, UIParent);
	self.infoFrame = frame;
	frame:SetWidth(342);
	frame:SetHeight(270);
	frame:SetMovable(true);
	frame:SetToplevel(true);
	frame:EnableMouse(true);
	frame:SetPoint("TOPLEFT", VanasKoSListFrame, "TOPRIGHT", -33, -28);
	frame:SetBackdrop({
			bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
			edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border", tile = true, tileSize = 32, edgeSize = 32,
			insets = { left = 11, right = 12, top = 12, bottom = 11 }
		});
		
	local htmlFrame = CreateFrame("SimpleHTML", nil, frame);
	self.htmlFrame= htmlFrame;
	htmlFrame:SetPoint("TOPLEFT", frame, "TOPLEFT", 15, -15);
	htmlFrame:SetWidth(296);
	htmlFrame:SetHeight(260);
	
	htmlFrame:SetFontObject("h1", "GameFontNormalLarge");
	htmlFrame:SetFontObject("h2", "GameFontNormal");
	htmlFrame:SetFontObject("h3", "GameFontNormalSmall");
	
	frame:Hide();
end

function VanasKoSDefaultLists:OnEnable()
end

function VanasKoSDefaultLists:OnDisable()
end

function VanasKoSDefaultLists:FilterFunction(key, value, searchBoxText)
	if(searchBoxText == "") then
		return true;
	end
	
	if(key:find(searchBoxText) ~= nil) then
		return true;
	end
	
	if(value.reason and (value.reason:lower():find(searchBoxText) ~= nil)) then
		return true;
	end
	
	if(value.owner and (value.owner:lower():find(searchBoxText) ~= nil)) then
		return true;
	end
	
	return false;
end

function VanasKoSDefaultLists:RenderButton(list, buttonIndex, button, key, value, buttonText1, buttonText2)
	if(list == "PLAYERKOS" or list == "HATELIST" or list == "NICELIST") then
		local displayname, guild, level, race, class, gender, zone, lastseen = VanasKoS:GetPlayerData(key);
		local owner = "";
		if(value.owner ~= nil and value.owner ~= "") then
			owner = string.Capitalize(value.owner);
		end
		if(displayname and level and race and class) then
			if(value.wanted) then
				displayname = "|cffff0000" .. displayname;
			end
			buttonText1:SetText(format(L["%s  Level %s %s %s %s"], displayname, level, race, class, owner));
		else
			if(value.wanted) then
				displayname = "|cffff0000" .. string.Capitalize(key);
			else
				displayname = string.Capitalize(key);
			end
			buttonText1:SetText(format(L["%s  %s"], displayname, owner));
		end
		if(lastseen) then
			local timespan = SecondsToTime(time() - lastseen);
			if(timespan == "") then
				timespan = L["0 Secs"];
			end
			
			buttonText2:SetText(format(L["%s (last seen: %s ago)"], string.Capitalize(value.reason), timespan));
		else
			buttonText2:SetText(format(L["%s (never seen)"], string.Capitalize(value.reason)));
		end
	elseif(VANASKOS.showList == "GUILDKOS") then
		local guildname = VanasKoS:GetGuildData(key);
		if(guildname ~= nil and guildname ~= "") then
			if(value.owner ~= nil and value.owner ~= "") then
				local owner = string.Capitalize(value.owner);
				buttonText1:SetText(format(L["%s  %s"], guildname, owner));
			else
				buttonText1:SetText(format(L["%s  %s"], guildname, ""));
			end
		else
			buttonText1:SetText(string.Capitalize(key));
		end
		buttonText2:SetText(string.Capitalize(value.reason));
	end
	
	button:Show();
end

function VanasKoSDefaultLists:IsOnList(list, name, guild)
	local listVar = VanasKoS:GetList(list);
	if(listVar and listVar[name]) then
		local creator = nil;
		local owner = nil;
		if(listVar[name].creator) then
			creator = listVar[name].creator;
		end
		if(listVar[name].owner) then
			owner = listVar[name].owner;
		end
		return listVar[name].reason, creator, owner;
	else
		return nil;
	end
end

-- don't call this directly, call it via VanasKoS:AddEntry - it expects name to be lower case!
function VanasKoSDefaultLists:AddEntry(list, name, data)
	if(list == "PLAYERKOS") then
		self.db.realm.koslist.players[name] = { ["reason"] = data['reason'], ["created"] = time(), ['creator'] = UnitName("player") };
	elseif(list == "GUILDKOS") then
		self.db.realm.koslist.guilds[name] = { ["reason"] = data['reason'], ["created"] = time(), ['creator'] = UnitName("player") };
	elseif(list == "HATELIST") then
		if(VanasKoS:IsOnList("NICELIST", name)) then
			self:Print(format(L["Entry %s is already on Nicelist"], name));
			return;
		end
		self.db.realm.hatelist.players[name] = { ["reason"] = data['reason'], ["created"] = time(), ['creator'] = UnitName("player")  };
	elseif(list == "NICELIST") then
		if(VanasKoS:IsOnList("HATELIST", name)) then
			self:Print(format(L["Entry %s is already on Hatelist"], name));
			return;
		end
		self.db.realm.nicelist.players[name] = { ["reason"] = data['reason'], ["created"] = time(), ['creator'] = UnitName("player")  };
	end

	self:TriggerEvent("VanasKoS_List_Entry_Added", list, name, data);
end

function VanasKoSDefaultLists:RemoveEntry(listname, name)
	local list = VanasKoS:GetList(listname);
	if(list and list[name]) then
		list[name] = nil;
		self:TriggerEvent("VanasKoS_List_Entry_Removed", list, name);
	end
end

function VanasKoSDefaultLists:GetList(list)
	if(list == "PLAYERKOS") then
		return self.db.realm.koslist.players;
	elseif(list == "GUILDKOS") then
		return self.db.realm.koslist.guilds;
	elseif(list == "HATELIST") then
		return self.db.realm.hatelist.players;
	elseif(list == "NICELIST") then
		return self.db.realm.nicelist.players;
	else
		return nil;
	end
end

function VanasKoSDefaultLists:ListButtonOnClick(button, frame)
	if(button == "RightButton") then
		local id = frame:GetID();
		local entry, value = VanasKoSGUI:GetListEntryForID(id);
		if(id == nil or entry == nil) then
			return;
		end

		dewdrop:Open(frame,
						'children', function()
										dewdrop:AddLine(
												'text', string.Capitalize(entry),
												'isTitle', true
										);
										
										if(value.owner == nil) then
											if(VANASKOS.showList ~= "PLAYERKOS") then
												dewdrop:AddLine(
													'text', L["Move to Player KoS"],
													'func', function()
															VanasKoS:RemoveEntry(VANASKOS.showList, entry);
															VanasKoS:AddEntry("PLAYERKOS", entry, value);
														end
												);
											end
											if(VANASKOS.showList ~= "HATELIST") then
												dewdrop:AddLine(
													'text', L["Move to Hatelist"],
													'func', function()
															VanasKoS:RemoveEntry(VANASKOS.showList, entry);
															VanasKoS:AddEntry("HATELIST", entry, value);
														end
												);
											end
											if(VANASKOS.showList ~= "NICELIST") then
												dewdrop:AddLine(
													'text', L["Move to Nicelist"],
													'func', function()
															VanasKoS:RemoveEntry(VANASKOS.showList, entry);
															VanasKoS:AddEntry("NICELIST", entry, value);
														end
												);
											end
										end
										if(VANASKOS.showList == "PLAYERKOS" and value.owner == nil) then
											dewdrop:AddLine(
												'text', L["Wanted"],
												'func', function()
															if(VANASKOS.showList ~= "PLAYERKOS" or
																value.owner ~= nil) then
																return;
															end
															if(not value.wanted) then
																value.wanted = true;
															else
																value.wanted = nil;
															end
															VanasKoSGUI:ScrollFrameUpdate();
													end,
												'checked', value.wanted
											);
										end
										dewdrop:AddLine(
											'text', L["Remove Entry"],
											'func', function()
													VanasKoS:RemoveEntry(VANASKOS.showList, entry);
												end
										);
							end,
						'point', "TOP",
						'cursorX', true,
						'cursorY', true);
	end
end

local text = nil;

function VanasKoSDefaultLists:ListButtonOnEnter(button, frame)
	local listindex, listval = VanasKoSGUI:GetListEntryForID(frame:GetID());
	local pdatalist = VanasKoS:GetList("PLAYERDATA")[listindex];
	text = "<html><body>";
	
		-- name
	if(pdatalist and pdatalist['displayname']) then
		text = text .. "<h1>" .. pdatalist['displayname'] .. "</h1><br />";
	else
		text = text .. "<h1>" .. string.Capitalize(listindex) .. "</h1><br />";
	end
		
	if(pdatalist ~= nil) then
		-- guild
		if(pdatalist['guild']) then
			text = text .. "<h2>&lt;|cffffffff" .. pdatalist['guild'] .. "|r&gt;</h2><br />";
		end
		
		-- level, race, class
		if(pdatalist['level'] and pdatalist['race'] and pdatalist['class']) then
			text = text .. "<h2>" .. format(L['Level %s %s %s'], pdatalist['level'], pdatalist['race'], pdatalist['class']) .. "</h2>";
		end
		
		-- last seen
		if(pdatalist['zone'] and pdatalist['lastseen']) then
			text = text .. "<h2>" .. format(L['Last seen at %s in %s'], date("%x", pdatalist['lastseen']), pdatalist['zone']) .. "</h2><br />";
		end
	end
	
	if(listval['owner']) then
		text = text .. "<h2>" .. format(L['Owner: %s'], listval['owner']) .. "</h2><br />";
	end
	
	if(listval['creator']) then
		text = text .. "<h2>" .. format(L['Creator: %s'], listval['creator']) .. "</h2><br />";
	end
	
	if(listval['created']) then
		text = text .. "<h2>" .. format(L['Created: %s'], date("%x", listval['created'])) .. "</h2><br />";
	end
	
	if(listval['sender']) then
		text = text .. "<h2>" .. format(L['Received from: %s'], listval['sender']) .. "</h2><br />";
	end

	if(listval['lastupdated']) then
		text = text .. "<h2>" .. format(L['Last updated: %s'], date("%x", listval['lastupdated'])) .. "</h2><br />";
	end
	
	local pvplog = VanasKoS:GetList("PVPLOG");
	if(pvplog) then
		pvplog = pvplog[listindex];
		if(pvplog) then
			local i = 0;
			local pvpencounter = "";
			for k,v in VanasKoSGUI:pairsByKeys(pvplog, nil) do -- sorted from old to new
				if(v.type and v.zone and v.myname) then
					if(v.type == 'win') then
						pvpencounter = "<h3>" .. format(L["%s: Win in %s (%s)"], date("%c", k), v.zone, v.myname)  .. "</h3><br/>" .. pvpencounter;
					else
						pvpencounter = "<h3>" .. format(L["%s: Loss in %s (%s)"], date("%c", k), v.zone, v.myname)  .. "</h3><br/>" .. pvpencounter;
					end
				end
				
				i = i + 1;
			end

			text = text .. "<h2>" .. L["PvP Encounter:"] .. " " .. i .. "</h2><br />";
			text = text .. pvpencounter;
		end
	end
	
	self.htmlFrame:SetText(text .. "</body></html>");
	
	self.infoFrame:Show();
end

function VanasKoSDefaultLists:ListButtonOnLeave(button, frame)
	self.infoFrame:Hide();
end

